using Grasshopper;
using Grasshopper.Kernel;
using Rhino.Geometry;
using System;
using System.Collections.Generic;
using Grasshopper.Kernel.Types;

namespace eh.s
{
    public class sComponent : GH_Component
    {
                                                                public sComponent()
          : base("OffsetSrf", "OffsetSrf",
            "Description",
            "eh.s", "Surface")
        {
        }

                                protected override void RegisterInputParams(GH_Component.GH_InputParamManager pManager)
                                {
                                    pManager.AddBrepParameter("PolySrf", "P", "PolySrf", GH_ParamAccess.item);
                                    pManager.AddNumberParameter("Distance", "d", "Distance Of Offset", GH_ParamAccess.item);
                                    pManager.AddBooleanParameter("Soild", "S", "Soild?", GH_ParamAccess.item);
                                    pManager.AddBooleanParameter("BothSide", "B", "BothSide?", GH_ParamAccess.item);
                                    pManager.AddBooleanParameter("round","R", "round?", GH_ParamAccess.item);
                                    pManager.AddBooleanParameter("MergFace","M", "MergFace?", GH_ParamAccess.item);
            }

                                protected override void RegisterOutputParams(GH_Component.GH_OutputParamManager pManager)
                                {
                                    pManager.AddBrepParameter("Brep", "B", "Brep", GH_ParamAccess.list);
                                    
        }

                                protected override void SolveInstance(IGH_DataAccess da
                                )
                                {
                                    Brep p = new Brep();
                                    var d = 0.00;
                                    var s = false;
                                    var b = false;
                                    var r = true;
                                    var m = false;
                                    Brep[] offset = null;
                                    
            da.GetData(0, ref p);
                                    da.GetData(1, ref d);
                                    da.GetData(2, ref s);
                                    da.GetData(3, ref b);
                                    da.GetData(4, ref r);
                                    da.GetData(5, ref m);
                                    p.Faces.SplitKinkyFaces(0.1, true);
                                    if (b && s)
                                    {
                                        offset = Brep.CreateOffsetBrep(p, d * (-1), false, r,
                                            Rhino.RhinoDoc.ActiveDoc.ModelAbsoluteTolerance, out _, out _);
                                        offset = Brep.CreateOffsetBrep(offset[0], d * (2), true, r,
                                            Rhino.RhinoDoc.ActiveDoc.ModelAbsoluteTolerance, out _, out _);
                                        da.SetData(0, offset[0]);
            }
                                    else if (b==true && s!=true)
                                    {
                                        var tmp = new List<Brep>();
                                    offset = Brep.CreateOffsetBrep(p, d * (-1), false, r, Rhino.RhinoDoc.ActiveDoc.ModelAbsoluteTolerance, out _, out _);

                                    var tmp2 = offset[0].DuplicateBrep();
                                    offset = Brep.CreateOffsetBrep(offset[0], d * (2), false, r, Rhino.RhinoDoc.ActiveDoc.ModelAbsoluteTolerance, out _, out _);
                                    tmp.Add(tmp2);tmp.Add(offset[0]);
                                    da.SetData(0, tmp);
                                   
                                    
            }
                                    else
                                    {
                                     offset = Brep.CreateOffsetBrep(p, d, s, r,
                                    Rhino.RhinoDoc.ActiveDoc.ModelAbsoluteTolerance, out _, out _); da.SetData(0, offset[0]);
            }


                                    if ((m && b && s)|| (m  && s))

                                    {
                                        offset[0].MergeCoplanarFaces(Rhino.RhinoDoc.ActiveDoc.ModelAbsoluteTolerance);

                                        da.SetData(0, offset[0]);
                                    }
                                }

     

        protected override System.Drawing.Bitmap Icon => Properties.Resources.offsetsrf;

                                                public override Guid ComponentGuid => new Guid("45002AA3-206C-4A2F-BDB7-C39E13803EF8");
    }
}